summaryrefslogtreecommitdiff
path: root/tests/tail-2/wait.sh
diff options
context:
space:
mode:
authorStefano Lattarini <stefano.lattarini@gmail.com>2012-08-30 14:13:12 +0200
committerJim Meyering <meyering@redhat.com>2012-08-30 18:55:59 +0200
commit9eb4c31eb78c28dd9f72d1cbb940270311be343c (patch)
treeea3078bc1b002a9f948ed41445ca32318002a1d3 /tests/tail-2/wait.sh
parent00f5ba15dd91a3d9780fe1fbd06a4df436ae6714 (diff)
downloadcoreutils-9eb4c31eb78c28dd9f72d1cbb940270311be343c.tar.xz
tests: add .sh and .pl suffixes to shell and perl tests, respectively
Not only this shrinks the size of the generated Makefile (from > 6300 lines to ~3000), but will allow further simplifications in future changes. * tests/Makefile.am (TEST_EXTENSIONS): Add '.sh' and '.pl'. (PL_LOG_COMPILER, SH_LOG_COMPILER): New, still defined simply to $(LOG_COMPILER) for the time being. (TESTS, root_tests): Adjust as described. * All tests: Rename as described.
Diffstat (limited to 'tests/tail-2/wait.sh')
-rwxr-xr-xtests/tail-2/wait.sh80
1 files changed, 80 insertions, 0 deletions
diff --git a/tests/tail-2/wait.sh b/tests/tail-2/wait.sh
new file mode 100755
index 000000000..587b44954
--- /dev/null
+++ b/tests/tail-2/wait.sh
@@ -0,0 +1,80 @@
+#!/bin/sh
+# Make sure that 'tail -f' returns immediately if a file doesn't exist
+# while 'tail -F' waits for it to appear.
+
+# Copyright (C) 2003-2012 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+. "${srcdir=.}/init.sh"; path_prepend_ ../src
+print_ver_ tail
+
+touch here || framework_failure_
+{ touch unreadable && chmod a-r unreadable; } || framework_failure_
+
+
+for inotify in ---disable-inotify ''; do
+ timeout 10 tail -s0.1 -f $inotify not_here
+ test $? = 124 && fail=1
+
+ if test ! -r unreadable; then # can't test this when root
+ timeout 10 tail -s0.1 -f $inotify unreadable
+ test $? = 124 && fail=1
+ fi
+
+ timeout 1 tail -s0.1 -f $inotify here 2>tail.err
+ test $? = 124 || fail=1
+
+ # 'tail -F' must wait in any case.
+
+ timeout 1 tail -s0.1 -F $inotify here 2>>tail.err
+ test $? = 124 || fail=1
+
+ if test ! -r unreadable; then # can't test this when root
+ timeout 1 tail -s0.1 -F $inotify unreadable
+ test $? = 124 || fail=1
+ fi
+
+ timeout 1 tail -s0.1 -F $inotify not_here
+ test $? = 124 || fail=1
+
+ grep -Ev 'inotify (resources exhausted|cannot be used)' tail.err > x
+ mv x tail.err
+ test -s tail.err && fail=1
+ :>tail.err
+
+ tail_F()
+ {
+ local delay="$1"
+
+ touch k || framework_failure_
+ tail -s.1 --max-unchanged-stats=2 -F $inotify k > tail.out &
+ pid=$!
+ sleep $delay
+ mv k l
+ sleep $delay
+ touch k
+ mv k l
+ sleep $delay
+ echo NO >> l
+ sleep $delay
+ kill $pid
+ rm -f k l
+
+ test ! -s tail.out
+ }
+ retry_delay_ tail_F .1 4 || fail=1
+done
+
+Exit $fail